#include <Adafruit_NeoPixel.h>

#define PIN        9
#define NUMPIXELS 8 
#define DELAYVAL 100 // Time (in milliseconds) to pause between pixels
#include <Servo.h>

Servo myservo;  // create servo object to control a servo
int Val = 0;   //which pixel we are on
int butL = 8;
int butR = 6; //IDEK
int butCOMMIT = 7; //button to commit changes to a new data entry.
int servoVals[] = {0,0,0,0,0}; //array of values of each LED.
int servo = 0; //angle servo motor is at.
int potPin = 5; //potentiometer attaches here
int potval;
Adafruit_NeoPixel strip(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

void setup() {
  myservo.attach(13); 
  strip.begin(); // INITIALIZE NeoPixel strip object (REQUIRED)
  strip.show();            // Turn OFF all pixels ASAP
  strip.setBrightness(10); // Set BRIGHTNESS low to reduce draw (max = 255)
  Serial.begin(9600);
//  Serial1.begin(9600); //USART Serial
  
  pinMode(butL,INPUT);
  pinMode(butR,INPUT);
  pinMode(butCOMMIT,INPUT);
  
 // Val = 0;
  
}

void loop() {
    //strip.setPixelColor(Val, strip.Color(0, 150, 0)); //set's the first LED to green
  //  Serial.print(Val);
    if (digitalRead(butR)==LOW){
      Serial.print("R");
      if (Val == 4)
      {
        Val = 0;
        //delay(500);
        
      }
      else
      {
        Val++; 
       // delay(500);
      }
    //  delay(100);
      updateStrip(Val); 
    } //move Val one to the right

    if (digitalRead(butL)==LOW){
      Serial.print("L");
      if (Val == 0)
      {
        Val = 4;
        Serial.print("YO");
        //strip.clear();
       delay(100);
        
      }
      else
      {
        Val--; 
        Serial.print("OK");
     //  delay(100);
      }
    //  delay(100);
      updateStrip(Val); 
    } //move Val one to the left.
   // updateStrip(Val); //update strip to the case of Val.

    potval = analogRead(potPin);
  // Serial.print(potval);

    servo = map(potval, 0, 1023, 0, 180); //read potentiometer, convert that to degrees servo
   // Serial.println(servo);
    myservo.write(servo);  


  if (digitalRead(butCOMMIT)==LOW){
      Serial.println("C");
      Serial.println(servo);
     updateArray();

    for(int i = 0; i < 5; i++)
      {
       Serial.println(servoVals[i]);
       Serial.write(servoVals[i]);//write values to serial monitor
      }

  }
    delay(DELAYVAL); // Pause before waiting for next button input.
    
}

void updateStrip(int readVal){
  switch (readVal) { //switch case statement corresponding to Val. 5 cases for five LEDs.
      case 0:
        strip.clear();
        strip.setPixelColor(0, strip.Color(0, 150, 0));
        strip.show(); 
        break;
      case 1:
        strip.clear();
        strip.setPixelColor(1, strip.Color(0, 150, 0));
        strip.show(); 
        break;
      case 2:
        strip.clear();
        strip.setPixelColor(2, strip.Color(0, 150, 0));
        strip.show(); 
        break;
      case 3:
        strip.clear();
        strip.setPixelColor(3, strip.Color(0, 150, 0));
        strip.show(); 
        break;
      case 4:
        strip.clear();
        strip.setPixelColor(4, strip.Color(0, 150, 0));
        strip.show(); 
        break;
      default:
        // turn all the LEDs off:
        strip.clear();
    }
   delay(200);
}
void updateArray(){ //can take a value between 0-5 corresponding to angles of the servo motor.
  if (servo < 20){
    servoVals[Val] = 6;
  }
  else if (servo >= 20 && servo <40){
    servoVals[Val] = 5;
  }
  else if (servo >= 40 && servo <60){
    servoVals[Val] = 4;
  }
  else if (servo >= 60 && servo <80){
    servoVals[Val] = 3;
  }
  else if (servo >= 80 && servo <100){
    servoVals[Val] = 2;
  }
  else if (servo >= 100){
    servoVals[Val] = 1;
  }
  delay(100);
}
